package api

import play.api.libs.json._
import model.BigDecimal
import model.VariantKey

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
trait AnalysisApi {
  /**
    * Get cloud evaluation of a position.
    * Get the cached evaluation of a position, if available.  Opening positions have more chances of being available. There are about 7 million positions in the database.  Up to 5 variations may be available. Variants are supported. 
    * @param fen FEN of the position
    * @param multiPv Number of variations
    * @param variant Variant
    */
  def apiCloudEval(fen: String, multiPv: Option[BigDecimal], variant: Option[VariantKey]): Unit
}
