package api

import play.api.libs.json._
import model.Ok
import model.UserExtended

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
trait RelationsApi {
  /**
    * Get users followed the logged in user
    * Users are streamed as [ndjson](#section/Introduction/Streaming-with-ND-JSON). 
    */
  def apiUserFollowing(): UserExtended

  /**
    * Follow a player
    * Follow a player, adding them to your list of Lichess friends. 
    */
  def followUser(username: String): Ok

  /**
    * Unfollow a player
    * Unfollow a player, removing them from your list of Lichess friends. 
    */
  def unfollowUser(username: String): Ok
}
