package api

import play.api.libs.json._
import model.TablebaseJson

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
trait TablebaseApi {
  /**
    * Tablebase lookup for Antichess
    */
  def antichessAtomic(): String

  /**
    * Tablebase lookup for Atomic chess
    */
  def tablebaseAtomic(): String

  /**
    * Tablebase lookup
    * **Endpoint: &lt;https://tablebase.lichess.ovh&gt;**  Example: &#x60;curl http://tablebase.lichess.ovh/standard?fen&#x3D;4k3/6KP/8/8/8/8/7p/8_w_-_-_0_1&#x60; 
    * @param fen FEN of the position. Underscores allowed.
    */
  def tablebaseStandard(fen: String): TablebaseJson
}
