package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameEventInfo.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameEventInfo(
  id: Option[String],
  source: Option[GameEventInfo.Source.Value],
  compat: Option[GameEventInfoCompat]
  additionalProperties: 
)

object GameEventInfo {
  implicit lazy val gameEventInfoJsonFormat: Format[GameEventInfo] = {
    val realJsonFormat = Json.format[GameEventInfo]
    val declaredPropNames = Set("id", "source", "compat")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameEventInfo =>
        val jsObj = realJsonFormat.writes(gameEventInfo)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }

  // noinspection TypeAnnotation
  object Source extends Enumeration {
    val Lobby = Value("lobby")
    val Friend = Value("friend")
    val Ai = Value("ai")
    val Api = Value("api")
    val Tournament = Value("tournament")
    val Position = Value("position")
    val Import = Value("import")
    val Importlive = Value("importlive")
    val Simul = Value("simul")
    val Relay = Value("relay")
    val Pool = Value("pool")
    val Swiss = Value("swiss")

    type Source = Value
    implicit lazy val SourceJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }
}

