package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameEventInfo_compat.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameEventInfoCompat(
  bot: Option[Boolean],
  board: Option[Boolean]
  additionalProperties: 
)

object GameEventInfoCompat {
  implicit lazy val gameEventInfoCompatJsonFormat: Format[GameEventInfoCompat] = {
    val realJsonFormat = Json.format[GameEventInfoCompat]
    val declaredPropNames = Set("bot", "board")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameEventInfoCompat =>
        val jsObj = realJsonFormat.writes(gameEventInfoCompat)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

