package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameEventPlayer.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameEventPlayer(
  aiLevel: Option[BigDecimal],
  id: Option[String],
  name: Option[String],
  title: Option[String],
  rating: Option[BigDecimal],
  provisional: Option[Boolean]
  additionalProperties: 
)

object GameEventPlayer {
  implicit lazy val gameEventPlayerJsonFormat: Format[GameEventPlayer] = {
    val realJsonFormat = Json.format[GameEventPlayer]
    val declaredPropNames = Set("aiLevel", "id", "name", "title", "rating", "provisional")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameEventPlayer =>
        val jsObj = realJsonFormat.writes(gameEventPlayer)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

