package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameFullEvent_perf.
  * @param name Translated perf name (e.g. \"Classical\" or \"Blitz\")
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameFullEventPerf(
  name: Option[String]
  additionalProperties: 
)

object GameFullEventPerf {
  implicit lazy val gameFullEventPerfJsonFormat: Format[GameFullEventPerf] = {
    val realJsonFormat = Json.format[GameFullEventPerf]
    val declaredPropNames = Set("name")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameFullEventPerf =>
        val jsObj = realJsonFormat.writes(gameFullEventPerf)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

