package model

import play.api.libs.json._

/**
  * Judgment annotation (only if played move was inaccurate)
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameJsonJudgment(
  name: Option[GameJsonJudgment.Name.Value],
  comment: Option[String]
  additionalProperties: 
)

object GameJsonJudgment {
  implicit lazy val gameJsonJudgmentJsonFormat: Format[GameJsonJudgment] = {
    val realJsonFormat = Json.format[GameJsonJudgment]
    val declaredPropNames = Set("name", "comment")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameJsonJudgment =>
        val jsObj = realJsonFormat.writes(gameJsonJudgment)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }

  // noinspection TypeAnnotation
  object Name extends Enumeration {
    val Inaccuracy = Value("Inaccuracy")
    val Mistake = Value("Mistake")
    val Blunder = Value("Blunder")

    type Name = Value
    implicit lazy val NameJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }
}

