package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameJson_opening.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameJsonOpening(
  eco: Option[String],
  name: Option[String],
  ply: Option[BigDecimal]
  additionalProperties: 
)

object GameJsonOpening {
  implicit lazy val gameJsonOpeningJsonFormat: Format[GameJsonOpening] = {
    val realJsonFormat = Json.format[GameJsonOpening]
    val declaredPropNames = Set("eco", "name", "ply")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameJsonOpening =>
        val jsObj = realJsonFormat.writes(gameJsonOpening)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

