package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameUser_analysis.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameUserAnalysis(
  inaccuracy: BigDecimal,
  mistake: BigDecimal,
  blunder: BigDecimal,
  acpl: BigDecimal
  additionalProperties: 
)

object GameUserAnalysis {
  implicit lazy val gameUserAnalysisJsonFormat: Format[GameUserAnalysis] = {
    val realJsonFormat = Json.format[GameUserAnalysis]
    val declaredPropNames = Set("inaccuracy", "mistake", "blunder", "acpl")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameUserAnalysis =>
        val jsObj = realJsonFormat.writes(gameUserAnalysis)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

