package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for inline_response_200.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class InlineResponse200(
  id: Option[String],
  name: Option[String],
  title: Option[String],
  online: Option[Boolean],
  playing: Option[Boolean],
  streaming: Option[Boolean],
  patron: Option[Boolean]
  additionalProperties: 
)

object InlineResponse200 {
  implicit lazy val inlineResponse200JsonFormat: Format[InlineResponse200] = {
    val realJsonFormat = Json.format[InlineResponse200]
    val declaredPropNames = Set("id", "name", "title", "online", "playing", "streaming", "patron")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { inlineResponse200 =>
        val jsObj = realJsonFormat.writes(inlineResponse200)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

