package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for inline_response_200_1.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class InlineResponse2001(
  currentPage: Option[BigDecimal],
  maxPerPage: Option[BigDecimal],
  currentPageResults: Option[List[Team]],
  nbResults: Option[BigDecimal],
  previousPage: Option[BigDecimal],
  nextPage: Option[BigDecimal],
  nbPages: Option[BigDecimal]
  additionalProperties: 
)

object InlineResponse2001 {
  implicit lazy val inlineResponse2001JsonFormat: Format[InlineResponse2001] = {
    val realJsonFormat = Json.format[InlineResponse2001]
    val declaredPropNames = Set("currentPage", "maxPerPage", "currentPageResults", "nbResults", "previousPage", "nextPage", "nbPages")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { inlineResponse2001 =>
        val jsObj = realJsonFormat.writes(inlineResponse2001)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

