package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for Perf.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class Perf(
  games: Option[Int],
  rating: Option[Int],
  rd: Option[Int],
  prog: Option[Int],
  prov: Option[Boolean]
  additionalProperties: 
)

object Perf {
  implicit lazy val perfJsonFormat: Format[Perf] = {
    val realJsonFormat = Json.format[Perf]
    val declaredPropNames = Set("games", "rating", "rd", "prog", "prov")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { perf =>
        val jsObj = realJsonFormat.writes(perf)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

