package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for Profile.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class Profile(
  country: Option[String],
  location: Option[String],
  bio: Option[String],
  firstName: Option[String],
  lastName: Option[String],
  fideRating: Option[Int],
  uscfRating: Option[Int],
  ecfRating: Option[Int],
  links: Option[String]
  additionalProperties: 
)

object Profile {
  implicit lazy val profileJsonFormat: Format[Profile] = {
    val realJsonFormat = Json.format[Profile]
    val declaredPropNames = Set("country", "location", "bio", "firstName", "lastName", "fideRating", "uscfRating", "ecfRating", "links")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { profile =>
        val jsObj = realJsonFormat.writes(profile)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

