package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for PuzzleRoundJson.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class PuzzleRoundJson(
  id: Option[String],
  date: Option[BigDecimal],
  win: Option[Boolean],
  puzzleRating: Option[BigDecimal]
  additionalProperties: 
)

object PuzzleRoundJson {
  implicit lazy val puzzleRoundJsonJsonFormat: Format[PuzzleRoundJson] = {
    val realJsonFormat = Json.format[PuzzleRoundJson]
    val declaredPropNames = Set("id", "date", "win", "puzzleRating")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { puzzleRoundJson =>
        val jsObj = realJsonFormat.writes(puzzleRoundJson)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

