package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for ArenaTournaments.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class ArenaTournaments(
  created: Option[List[OasAnyTypeNotMapped]],
  started: Option[List[OasAnyTypeNotMapped]],
  finished: Option[List[OasAnyTypeNotMapped]]
  additionalProperties: 
)

object ArenaTournaments {
  implicit lazy val arenaTournamentsJsonFormat: Format[ArenaTournaments] = {
    val realJsonFormat = Json.format[ArenaTournaments]
    val declaredPropNames = Set("created", "started", "finished")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { arenaTournaments =>
        val jsObj = realJsonFormat.writes(arenaTournaments)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

