package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for ChallengeCanceledEvent.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class ChallengeCanceledEvent(
  challenge: Option[ChallengeJson]
  additionalProperties: 
)

object ChallengeCanceledEvent {
  implicit lazy val challengeCanceledEventJsonFormat: Format[ChallengeCanceledEvent] = {
    val realJsonFormat = Json.format[ChallengeCanceledEvent]
    val declaredPropNames = Set("challenge")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { challengeCanceledEvent =>
        val jsObj = realJsonFormat.writes(challengeCanceledEvent)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

