package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for ChatLineEvent.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class ChatLineEvent(
  room: ChatLineEvent.Room.Value,
  username: String,
  text: String
  additionalProperties: 
)

object ChatLineEvent {
  implicit lazy val chatLineEventJsonFormat: Format[ChatLineEvent] = {
    val realJsonFormat = Json.format[ChatLineEvent]
    val declaredPropNames = Set("room", "username", "text")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { chatLineEvent =>
        val jsObj = realJsonFormat.writes(chatLineEvent)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }

  // noinspection TypeAnnotation
  object Room extends Enumeration {
    val Player = Value("player")
    val Spectator = Value("spectator")

    type Room = Value
    implicit lazy val RoomJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }
}

