package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for Clock.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class Clock(
  limit: Option[Int],
  increment: Option[Int]
  additionalProperties: 
)

object Clock {
  implicit lazy val clockJsonFormat: Format[Clock] = {
    val realJsonFormat = Json.format[Clock]
    val declaredPropNames = Set("limit", "increment")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { clock =>
        val jsObj = realJsonFormat.writes(clock)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

