package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for Count.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class Count(
  all: Option[Int],
  rated: Option[Int],
  ai: Option[Int],
  draw: Option[Int],
  drawH: Option[Int],
  loss: Option[Int],
  lossH: Option[Int],
  win: Option[Int],
  winH: Option[Int],
  bookmark: Option[Int],
  playing: Option[Int],
  `import`: Option[Int],
  me: Option[Int]
  additionalProperties: 
)

object Count {
  implicit lazy val countJsonFormat: Format[Count] = {
    val realJsonFormat = Json.format[Count]
    val declaredPropNames = Set("all", "rated", "ai", "draw", "drawH", "loss", "lossH", "win", "winH", "bookmark", "playing", "`import`", "me")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { count =>
        val jsObj = realJsonFormat.writes(count)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

