package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameJson_clock.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameJsonClock(
  initial: Option[BigDecimal],
  increment: Option[BigDecimal],
  totalTime: Option[BigDecimal]
  additionalProperties: 
)

object GameJsonClock {
  implicit lazy val gameJsonClockJsonFormat: Format[GameJsonClock] = {
    val realJsonFormat = Json.format[GameJsonClock]
    val declaredPropNames = Set("initial", "increment", "totalTime")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameJsonClock =>
        val jsObj = realJsonFormat.writes(gameJsonClock)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

