package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameUser.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameUser(
  user: Option[LightUser],
  rating: Option[BigDecimal],
  ratingDiff: Option[BigDecimal],
  name: Option[String],
  provisional: Option[Boolean],
  aiLevel: Option[BigDecimal],
  analysis: Option[GameUserAnalysis],
  team: Option[String]
  additionalProperties: 
)

object GameUser {
  implicit lazy val gameUserJsonFormat: Format[GameUser] = {
    val realJsonFormat = Json.format[GameUser]
    val declaredPropNames = Set("user", "rating", "ratingDiff", "name", "provisional", "aiLevel", "analysis", "team")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameUser =>
        val jsObj = realJsonFormat.writes(gameUser)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

