package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for inline_response_200_3.
  * @param in Incoming challenges i.e. targeted at you
  * @param out Outgoing challenges i.e. created by you
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class InlineResponse2003(
  in: Option[List[ChallengeJson]],
  out: Option[List[ChallengeJson]]
  additionalProperties: 
)

object InlineResponse2003 {
  implicit lazy val inlineResponse2003JsonFormat: Format[InlineResponse2003] = {
    val realJsonFormat = Json.format[InlineResponse2003]
    val declaredPropNames = Set("in", "out")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { inlineResponse2003 =>
        val jsObj = realJsonFormat.writes(inlineResponse2003)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

