package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for LightUser.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class LightUser(
  name: Option[String],
  title: Option[Title],
  patron: Option[Boolean],
  id: Option[String]
  additionalProperties: 
)

object LightUser {
  implicit lazy val lightUserJsonFormat: Format[LightUser] = {
    val realJsonFormat = Json.format[LightUser]
    val declaredPropNames = Set("name", "title", "patron", "id")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { lightUser =>
        val jsObj = realJsonFormat.writes(lightUser)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

