package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for Perfs.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class Perfs(
  chess960: Option[Perf],
  atomic: Option[Perf],
  racingKings: Option[Perf],
  ultraBullet: Option[Perf],
  blitz: Option[Perf],
  kingOfTheHill: Option[Perf],
  bullet: Option[Perf],
  correspondence: Option[Perf],
  horde: Option[Perf],
  puzzle: Option[Perf],
  classical: Option[Perf],
  rapid: Option[Perf],
  storm: Option[StormPerf]
  additionalProperties: 
)

object Perfs {
  implicit lazy val perfsJsonFormat: Format[Perfs] = {
    val realJsonFormat = Json.format[Perfs]
    val declaredPropNames = Set("chess960", "atomic", "racingKings", "ultraBullet", "blitz", "kingOfTheHill", "bullet", "correspondence", "horde", "puzzle", "classical", "rapid", "storm")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { perfs =>
        val jsObj = realJsonFormat.writes(perfs)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

