package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for PlayTime.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class PlayTime(
  total: Option[Int],
  tv: Option[Int]
  additionalProperties: 
)

object PlayTime {
  implicit lazy val playTimeJsonFormat: Format[PlayTime] = {
    val realJsonFormat = Json.format[PlayTime]
    val declaredPropNames = Set("total", "tv")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { playTime =>
        val jsObj = realJsonFormat.writes(playTime)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

