package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for StormPerf.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class StormPerf(
  runs: Option[Int],
  score: Option[Int]
  additionalProperties: 
)

object StormPerf {
  implicit lazy val stormPerfJsonFormat: Format[StormPerf] = {
    val realJsonFormat = Json.format[StormPerf]
    val declaredPropNames = Set("runs", "score")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { stormPerf =>
        val jsObj = realJsonFormat.writes(stormPerf)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

