package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for Team.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class Team(
  id: Option[String],
  name: Option[String],
  description: Option[String],
  open: Option[Boolean],
  leader: Option[LightUser],
  leaders: Option[List[LightUser]],
  nbMembers: Option[Int],
  location: Option[String]
  additionalProperties: 
)

object Team {
  implicit lazy val teamJsonFormat: Format[Team] = {
    val realJsonFormat = Json.format[Team]
    val declaredPropNames = Set("id", "name", "description", "open", "leader", "leaders", "nbMembers", "location")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { team =>
        val jsObj = realJsonFormat.writes(team)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

