package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for TimeControlClock_allOf.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class TimeControlClockAllOf(
  limit: Option[BigDecimal],
  increment: Option[BigDecimal],
  show: Option[String]
  additionalProperties: 
)

object TimeControlClockAllOf {
  implicit lazy val timeControlClockAllOfJsonFormat: Format[TimeControlClockAllOf] = {
    val realJsonFormat = Json.format[TimeControlClockAllOf]
    val declaredPropNames = Set("limit", "increment", "show")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { timeControlClockAllOf =>
        val jsObj = realJsonFormat.writes(timeControlClockAllOf)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

