package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for User.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class User(
  id: Option[String],
  username: Option[String],
  online: Option[Boolean],
  perfs: Option[Perfs],
  createdAt: Option[Int],
  disabled: Option[Boolean],
  tosViolation: Option[Boolean],
  profile: Option[Profile],
  seenAt: Option[Int],
  patron: Option[Boolean],
  verified: Option[Boolean],
  playTime: Option[PlayTime],
  title: Option[Title]
  additionalProperties: 
)

object User {
  implicit lazy val userJsonFormat: Format[User] = {
    val realJsonFormat = Json.format[User]
    val declaredPropNames = Set("id", "username", "online", "perfs", "createdAt", "disabled", "tosViolation", "profile", "seenAt", "patron", "verified", "playTime", "title")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { user =>
        val jsObj = realJsonFormat.writes(user)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

