package model

import play.api.libs.json._
import java.net.URI

/**
  * Represents the Swagger definition for UserExtended.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class UserExtended(
  id: Option[String],
  username: Option[String],
  online: Option[Boolean],
  perfs: Option[Perfs],
  createdAt: Option[Int],
  disabled: Option[Boolean],
  tosViolation: Option[Boolean],
  profile: Option[Profile],
  seenAt: Option[Int],
  patron: Option[Boolean],
  verified: Option[Boolean],
  playTime: Option[PlayTime],
  title: Option[Title],
  url: Option[URI],
  playing: Option[URI],
  completionRate: Option[Int],
  count: Option[Count],
  streaming: Option[Boolean],
  followable: Option[Boolean],
  following: Option[Boolean],
  blocking: Option[Boolean],
  followsYou: Option[Boolean]
)

object UserExtended {
  implicit lazy val userExtendedJsonFormat: Format[UserExtended] = Json.format[UserExtended]
}

