package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for Variant.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class Variant(
  key: Option[VariantKey],
  name: Option[String],
  short: Option[String]
  additionalProperties: 
)

object Variant {
  implicit lazy val variantJsonFormat: Format[Variant] = {
    val realJsonFormat = Json.format[Variant]
    val declaredPropNames = Set("key", "name", "short")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { variant =>
        val jsObj = realJsonFormat.writes(variant)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

